import {
  EdgeChange,
  EdgeSelectionChange,
  ElementChange,
  FlowElement,
  FlowElements,
  GraphNode,
  NodeChange,
  NodeSelectionChange,
  NodePositionChange,
  Getters,
  CoordinateExtent,
  XYPosition,
  GraphEdge,
} from '../types'
declare type CreatePositionChangeParams = {
  node: GraphNode
  nodeExtent: CoordinateExtent
  diff?: XYPosition
  dragging?: boolean
}
export declare const applyChanges: <
  T extends FlowElement<import('../types').ElementData, import('../types').ElementData> = GraphNode<
    import('../types').ElementData
  >,
  C extends ElementChange = T extends GraphNode<import('../types').ElementData> ? NodeChange : EdgeChange,
>(
  changes: C[],
  elements: T[],
) => T[]
export declare const applyEdgeChanges: (
  changes: EdgeChange[],
  edges: GraphEdge[],
) => GraphEdge<import('../types').ElementData, any, any>[]
export declare const applyNodeChanges: (changes: NodeChange[], nodes: GraphNode[]) => GraphNode<import('../types').ElementData>[]
export declare const createSelectionChange: (id: string, selected: boolean) => NodeSelectionChange | EdgeSelectionChange
export declare const createPositionChange: (
  { node, diff, dragging, nodeExtent }: CreatePositionChangeParams,
  curr: GraphNode[],
) => NodePositionChange
export declare const getSelectionChanges: (
  items: FlowElements<import('../types').ElementData, import('../types').ElementData>,
  selectedIds: string[],
  getNode: Getters['getNode'],
) => NodeSelectionChange[]
export {}
